class Graph
  include Rjb

  FONT_SIZE = 9

  def initialize(w, h)
    @width = w
    @height = h
    @image = BufferedImage.new(w, h, BufferedImage.TYPE_INT_ARGB)
  end

  def draw(districts)
    g = @image.getGraphics
    g.setColor(Color.BLACK)
    g.setFont(Font.new(Font.DIALOG, 0, FONT_SIZE))
    delta = @width / (districts.size + 1)
    x = FONT_SIZE + 1
    max_y = districts.max {|r0, r1| r0.total - r1.total}.total
    bottom = @height - (FONT_SIZE + 1) * 2
    districts.each_with_index do |n, i|
      h = n.total * @height / max_y
      g.fillRect(x, bottom - h, delta / 2, h)
      g.drawString(n.name, x - FONT_SIZE / 2, 
                   (i & 1 == 0) ? @height - (FONT_SIZE + 1) : @height - 1)
      x += delta
    end
    g.dispose
  end

  def png
    bout = ByteArrayOutputStream.new
    ImageIO.write(@image, "png", bout)
    bout.toByteArray
  end
end
