#!/usr/local/bin/ruby
#http://java.sun.com/javase/6/docs/technotes/guides/security/crypto/CryptoSpec.html
#http://java.sun.com/javase/ja/6/docs/ja/technotes/guides/security/crypto/CryptoSpec.html

require 'rjb'

TAG_ASN_1_OCTET = 4

unless ARGV.length == 3 && /^[ed]/ =~ ARGV[0] && File.exist?(ARGV[1])
  puts 'usage: ruby cipher e|d file password'
  exit 1
end

Cipher = Rjb::import('javax.crypto.Cipher')
SecretKeySpec = Rjb::import('javax.crypto.spec.SecretKeySpec')
AlgorithmParameters = Rjb::import('java.security.AlgorithmParameters')

pass = ARGV[2].dup
if pass.length < 16
  pass << "\x21" * (16 - pass.length)
else
  pass.slice!(0, 16)
end

key = SecretKeySpec.new_with_sig('[BLjava.lang.String;', pass, 'AES')
c = Cipher.getInstance('AES/CBC/PKCS5Padding')

iv = Array.new(18, 127)
iv[0] = TAG_ASN_1_OCTET
iv[1] = 16
ap = AlgorithmParameters.getInstance('AES')
ap.init(iv)

if ARGV[0][0] == ?e
  c.init(Cipher.ENCRYPT_MODE, key, ap)
else
  c.init(Cipher.DECRYPT_MODE, key, ap)
end

data = ''
File.open(ARGV[1], 'rb') do |f|
  data = f.read
end

result = c._invoke('doFinal', '[B', data)

File.open("#{ARGV[1]}.new", 'wb') do |f|
  f.write(result)
end

